## net.sf.saxon.pattern
Class LocationPathPattern

    java.lang.Object
      net.sf.saxon.pattern.Pattern
          net.sf.saxon.pattern.LocationPathPattern

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, Container, PatternFinder

    public final class LocationPathPattern

extends Pattern

A LocationPathPattern represents a path, for example of the form A/B/C... The components are represented as a linked list, each component pointing to its predecessor

See Also:
  Serialized Form

Field Summary
`Pattern` `ancestorPattern`
`protected Expression` `equivalentExpr`
`protected Expression[]` `filters`
`protected boolean` `firstElementPattern`
`protected boolean` `lastElementPattern`
`NodeTest` `nodeTest`
`protected int` `numberOfFilters`
`Pattern` `parentPattern`
`protected boolean` `specialFilter`

Constructor Summary
`LocationPathPattern()` Create a LocationPathPattern

Method Summary
`void` `addFilter(Expression filter)` Add a filter to the pattern (while under construction)
`int` `allocateSlots(StaticContext env, SlotManager slotManager, int nextFree)` Allocate slots to any variables used within the pattern
`Pattern` `analyze(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the pattern, performing any type-dependent optimizations.
`boolean` `equals(java.lang.Object other)` Determine whether this pattern is the same as another pattern
`Pattern` `getAncestorPattern()` Get the pattern applying to an ancestor node, if there is one
`int` `getDependencies()` Get the dependencies of the pattern.
`Expression[]` `getFilters()` Get the filters assocated with the last step in the pattern
`int` `getFingerprint()` Determine the fingerprint of nodes to which this pattern applies.
`int` `getNodeKind()` Determine the types of nodes to which this pattern applies.
`NodeTest` `getNodeTest()` Get a NodeTest that all the nodes matching this pattern must satisfy
`Pattern` `getParentPattern()` Get the pattern applying to the parent node, if there is one
`int` `hashCode()` Hashcode supporting equals()
`protected boolean` `internalMatches(NodeInfo node, XPathContext context)` Test whether the pattern matches, but without changing the current() node
`java.util.Iterator` `iterateSubExpressions()` Iterate over the subexpressions within this pattern
`boolean` `matches(NodeInfo node, XPathContext context)` Determine whether the pattern matches a given node.
`void` `promote(PromotionOffer offer)` Offer promotion for subexpressions within this pattern.
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` `resolveCurrent(LetExpression let, PromotionOffer offer, boolean topLevel)` If the pattern contains any calls on current(), this method is called to modify such calls to become variable references to a variable declared in a specially-allocated local variable
`void` `setExecutable(Executable executable)` Set the executable containing this pattern
`Pattern` `simplify(ExpressionVisitor visitor)` Simplify the pattern: perform any context-independent optimisations

Methods inherited from class net.sf.saxon.pattern.Pattern
`getColumnNumber, getDefaultPriority, getExecutable, getHostLanguage, getLineNumber, getLocationProvider, getPublicId, getSystemId, make, makeSearchExpression, selectNodes, setLineNumber, setOriginalText, setSystemId, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### parentPattern

    public Pattern parentPattern

### ancestorPattern

    public Pattern ancestorPattern

### nodeTest

    public NodeTest nodeTest

### filters

    protected Expression[] filters

### numberOfFilters

    protected int numberOfFilters

### equivalentExpr

    protected Expression equivalentExpr

### firstElementPattern

    protected boolean firstElementPattern

### lastElementPattern

    protected boolean lastElementPattern

### specialFilter

    protected boolean specialFilter

Constructor Detail

### LocationPathPattern

    public LocationPathPattern()

  Create a LocationPathPattern

Method Detail

### addFilter

    public void addFilter(Expression filter)

  Add a filter to the pattern (while under construction)

  Parameters:
    `filter` - The predicate (a boolean expression or numeric expression) to be added

### setExecutable

    public void setExecutable(Executable executable)

  Set the executable containing this pattern

  Overrides:
    `setExecutable` in class `Pattern`
  Parameters:
    `executable` - the executable

### getFilters

    public Expression[] getFilters()

  Get the filters assocated with the last step in the pattern

  Returns:
    an array of expression holding the filter predicates in order

### getParentPattern

    public Pattern getParentPattern()

  Get the pattern applying to the parent node, if there is one

  Returns:
    the parent pattern, for example if the pattern is a/b[1]/c then the parent pattern is a/b[1]

### getAncestorPattern

    public Pattern getAncestorPattern()

  Get the pattern applying to an ancestor node, if there is one

  Returns:
    the ancestor pattern, for example if the pattern is a/b[1]//c then the ancestor pattern is a/b[1]

### simplify

    public Pattern simplify(ExpressionVisitor visitor)
                     throws XPathException

  Simplify the pattern: perform any context-independent optimisations

  Overrides:
    `simplify` in class `Pattern`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### analyze

    public Pattern analyze(ExpressionVisitor visitor,
                           ItemType contextItemType)
                    throws XPathException

  Type-check the pattern, performing any type-dependent optimizations.

  Overrides:
    `analyze` in class `Pattern`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the type of the context item at the point where the pattern appears
  Returns:
    the optimised Pattern
  Throws:
    `XPathException`

### getDependencies

    public int getDependencies()

  Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.

  Overrides:
    `getDependencies` in class `Pattern`
  Returns:
    the dependencies, as a bit-significant mask

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Iterate over the subexpressions within this pattern

  Overrides:
    `iterateSubExpressions` in class `Pattern`
  Returns:
    an iterator over the subexpressions. Default implementation returns an empty sequence

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Pattern`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### allocateSlots

    public int allocateSlots(StaticContext env,
                             SlotManager slotManager,
                             int nextFree)

  Allocate slots to any variables used within the pattern

  Overrides:
    `allocateSlots` in class `Pattern`
  Parameters:
    `env` - the static context in the XSLT stylesheet
    `slotManager` -
    `nextFree` - the next slot that is free to be allocated @return the next slot that is free to be allocated

### promote

    public void promote(PromotionOffer offer)
                 throws XPathException

  Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

  Overrides:
    `promote` in class `Pattern`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### matches

    public boolean matches(NodeInfo node,
                           XPathContext context)
                    throws XPathException

  Determine whether the pattern matches a given node.

  Specified by:
    `matches` in class `Pattern`
  Parameters:
    `node` - the node to be tested
    `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
  Returns:
    true if the pattern matches, else false
  Throws:
    `XPathException`

### internalMatches

    protected boolean internalMatches(NodeInfo node,
                                      XPathContext context)
                               throws XPathException

  Test whether the pattern matches, but without changing the current() node

  Overrides:
    `internalMatches` in class `Pattern`
  Parameters:
    `node` - The NodeInfo representing the Element or other node to be tested against the Pattern
    `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
  Returns:
    true if the node matches the Pattern, false otherwise
  Throws:
    `XPathException`

### getNodeKind

    public int getNodeKind()

  Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Node.NODE

  Overrides:
    `getNodeKind` in class `Pattern`
  Returns:
    the type of node matched by this pattern. e.g. Node.ELEMENT or Node.TEXT

### getFingerprint

    public int getFingerprint()

  Determine the fingerprint of nodes to which this pattern applies. Used for optimisation.

  Overrides:
    `getFingerprint` in class `Pattern`
  Returns:
    the fingerprint of nodes matched by this pattern.

### getNodeTest

    public NodeTest getNodeTest()

  Get a NodeTest that all the nodes matching this pattern must satisfy

  Specified by:
    `getNodeTest` in class `Pattern`
  Returns:
    a NodeTest, as specific as possible, which all the matching nodes satisfy

### resolveCurrent

    public void resolveCurrent(LetExpression let,
                               PromotionOffer offer,
                               boolean topLevel)
                        throws XPathException

  If the pattern contains any calls on current(), this method is called to modify such calls to become variable references to a variable declared in a specially-allocated local variable

  Parameters:
    `let` - the expression that assigns the local variable. This returns a dummy result, and is executed just before evaluating the pattern, to get the value of the context item into the variable.
    `offer` - A PromotionOffer used to process the expressions and change the call on current() into a variable reference
    `topLevel` -
  Throws:
    `XPathException`

### equals

    public boolean equals(java.lang.Object other)

  Determine whether this pattern is the same as another pattern

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `other` - the other object

### hashCode

    public int hashCode()

  Hashcode supporting equals()

  Overrides:
    `hashCode` in class `java.lang.Object`

Copyright (c) Saxonica Limited. All rights reserved.